function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { isVNode, provide, reactive, getCurrentInstance } from 'vue';
export var flattenVNodes = children => {
  var result = [];

  var traverse = children => {
    if (Array.isArray(children)) {
      children.forEach(child => {
        if (isVNode(child)) {
          var _child$component;

          result.push(child);

          if ((_child$component = child.component) !== null && _child$component !== void 0 && _child$component.subTree) {
            traverse(child.component.subTree.children);
          }

          if (child.children) {
            traverse(child.children);
          }
        }
      });
    }
  };

  traverse(children);
  return result;
};
export var sortChildren = (parent, publicChildren, internalChildren) => {
  var VNodes = flattenVNodes(parent.subTree.children);
  internalChildren.sort( // eslint-disable-next-line comma-dangle
  (a, b) => VNodes.indexOf(a.vnode) - VNodes.indexOf(b.vnode));
  var orderedPublicChildren = internalChildren.map(item => item.proxy);
  publicChildren.sort((a, b) => {
    var indexA = orderedPublicChildren.indexOf(a);
    var indexB = orderedPublicChildren.indexOf(b);
    return indexA - indexB;
  });
};
export var createProvider = key => {
  var publicChildren = reactive([]);
  var internalChildren = reactive([]);
  var parent = getCurrentInstance();

  var provider = value => {
    var link = child => {
      if (child.proxy) {
        internalChildren.push(child);
        publicChildren.push(child.proxy);
        sortChildren(parent, publicChildren, internalChildren);
      }
    };

    var unlink = child => {
      var idx = internalChildren.indexOf(child);
      publicChildren.splice(idx, 1);
      internalChildren.splice(idx, 1);
    };

    provide(key, _objectSpread({
      link,
      unlink,
      children: publicChildren,
      internalChildren
    }, value));
  };

  return {
    children: publicChildren,
    provider
  };
};