import { onMounted, unref, onDeactivated, onBeforeUnmount, watch } from 'vue';
import { useState } from '../useState';
export var useEventListener = (event, listener, options = {}) => {
  var {
    target = window
  } = options;
  var [elSnapshot, setElSnapshot] = useState();

  var remove = () => {};

  onMounted(() => {
    var element = unref(target);

    if (element) {
      setElSnapshot(element);
    }
  });
  watch(elSnapshot, el => {
    if (!el) return;
    el.addEventListener(event, listener, options);

    remove = () => el.removeEventListener(event, listener, options);
  });
  onBeforeUnmount(remove);
  onDeactivated(remove);
};