"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useClickAway = void 0;

var _vue = require("vue");

var _useEventListener = require("../useEventListener");

var defaultOptions = {
  event: 'click'
};

var useClickAway = (listener, target, options = defaultOptions) => {
  var onClick = evt => {
    var element = (0, _vue.unref)(target);

    if (element && !element.contains(evt.target)) {
      listener(evt);
    }
  };

  (0, _useEventListener.useEventListener)(options.event, onClick, {
    target: document
  });
};

exports.useClickAway = useClickAway;