"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useProvider = void 0;

var _vue = require("vue");

var _excluded = ["link", "unlink", "internalChildren"];

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

var useProvider = key => {
  var context = (0, _vue.inject)(key, null);

  if (context) {
    var instance = (0, _vue.getCurrentInstance)();

    var {
      link: _link,
      unlink: _unlink,
      internalChildren
    } = context,
        rest = _objectWithoutProperties(context, _excluded);

    _link(instance);

    (0, _vue.onUnmounted)(() => _unlink(instance));
    var idx = (0, _vue.computed)(() => internalChildren.indexOf(instance));
    return {
      context: rest,
      idx: idx.value
    };
  }

  return {
    context: null,
    idx: -1
  };
};

exports.useProvider = useProvider;