"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useEventListener = void 0;

var _vue = require("vue");

var _useState = require("../useState");

var useEventListener = (event, listener, options = {}) => {
  var {
    target = window
  } = options;
  var [elSnapshot, setElSnapshot] = (0, _useState.useState)();

  var remove = () => {};

  (0, _vue.onMounted)(() => {
    var element = (0, _vue.unref)(target);

    if (element) {
      setElSnapshot(element);
    }
  });
  (0, _vue.watch)(elSnapshot, el => {
    if (!el) return;
    el.addEventListener(event, listener, options);

    remove = () => el.removeEventListener(event, listener, options);
  });
  (0, _vue.onBeforeUnmount)(remove);
  (0, _vue.onDeactivated)(remove);
};

exports.useEventListener = useEventListener;